﻿local addonName, FLC = ...; -- gets addon-local variables

-- Constants
local STRING_MAX = 255;

----------------------------------------------------------------------------------------------------
-- Hooking and modifying SendChat

local hooked_sendChatMessage = SendChatMessage; -- original SendChatMessage (Hook)
--SendChatMessage = FLC_SendChatMessage;

function SendChatMessage( msg, chatType, language, channel )

    if  ( FLC.on == true and FLC.isAllowedChannel(chatType) and FLC.speakingOwnLanguage() ) then --and FLC.activeLanguage ~= FLC.commonLanguage
        -- use own/native language with language tag
        
        local out1, out2 = FLC.partSpeech( msg, FLC.activeLanguage, STRING_MAX );
        
        -- creates the language tag
        local tag;
        if ( FLC.tempLanguage == nil or FLC.tempLanguage == "" ) then
            tag = FLC.buildTag(FLC.activeLanguage);
        else
            if (FLC.tempLanguage ~= FLC.commonLanguage) then
                tag = FLC.buildTag(FLC.tempLanguage);
            end
            FLC.tempLanguage = "";
        end
        
        -- uses the language tag in your text(s)
        if (out1 ~= "") then
            -- prepares and sends out1 only if it exists
            out1 = FLC.changeArticulation(out1, chatType, language, channel );
            out1 = FLC.enhanceSpeech(tag,out1);
            hooked_sendChatMessage(  out1, chatType, FLC.commonLanguage, channel );
        end    
        if (out2 ~= "") then
            -- prepares and sends out2 only if it exists
            out2 = FLC.changeArticulation(out2, chatType, language, channel );
            out2 = FLC.enhanceSpeech(tag,out2);
            hooked_sendChatMessage(  out2, chatType, FLC.commonLanguage, channel );
        end
        
    elseif ( FLC.on == true and FLC.isAllowedChannel(chatType) and not FLC.speakingOwnLanguage() ) then
        -- use common language with textual specialities
        local out1 = FLC.changeArticulation(msg, chatType, language, channel );
        hooked_sendChatMessage( out1 , chatType, language, channel );
        
    else
        -- use the standard SendChatMessage
        hooked_sendChatMessage(  msg, chatType, language, channel );
    end
    
end