﻿local addonName, FLC = ...; -- gets addon-local variables


----------------------------------------------------------------------------------------------------
-- DEBUG Test functions

--/ Output of the MIV (Most Interesting Variables), displaying the state of the addon
function FLC.Debug_testConfig( show )
    local s = "";
    s = s .. "FairLanguage Config:" .. "\n";
    s = s .. "    version = " .. tostring(GetAddOnMetadata(addonName,"Version")) .. "\n";
    s = s .. "    isOn = " .. tostring(FLC.on) .. "\n";
    s = s .. "    isOwn = " .. tostring(FLC.isOwn) .. "\n";
    s = s .. "    speakingOwnLang = " .. tostring(FLC.speakingOwnLanguage()) .. "\n";
    s = s .. "    editBox = " .. tostring(DEFAULT_CHAT_FRAME.editBox.language) .. "\n";
    s = s .. "    BlizzLanguages = " .. tostring(FLC.numLanguages) .. "\n";
    s = s .. "    commonLanguage = " .. tostring(FLC.commonLanguage) .. "\n";
    s = s .. "    nativeLanguage = " .. tostring(FLC.nativeLanguage) .. "\n";
    s = s .. "    activeLanguage = " .. tostring(FLC.activeLanguage) .. "\n";
    s = s .. "    prevLang = " .. tostring(FLC.prevLanguage) .. "";
    
    if show then
        print(s);
    end
    return s;
end

function FLC.Debug_testMenu( show )
    local s = "";
    s = s .. "FairLanguage Menu:" .. "\n";
    s = s .. "    Number = " .. LanguageMenu.numButtons .. " (incl. default languages)" .. "\n";
    s = s .. "    Own languages ("..#(FLC.menuLanguages)..") are" .. "";
    
    if (FLC.menuLanguages ~= nil and #FLC.menuLanguages > 0) then
        for k,v in ipairs (FLC.menuLanguages) do
            s = s .. "\n         * " .. v .. "";   
        end
    end
    
    if show then
        print(s);
    end
    
    return s;
end

function FLC.Debug_Copy()
    local config = FLC.Debug_testConfig( false );
    local menu = FLC.Debug_testMenu( false );
    
    assert(false, "Please copy this message: \n" .. config .. "\n" .. menu);
end


----------------------------------------------------------------------------------------------------
-- DEBUG Slash commands

SlashCmdList['FAIRLANGUAGE_DEBUG_SLASHCMD'] = function( msg, ... )
    local command, args = msg:match("^(%S*)%s*(.-)$");
    
    if ( command == "config" ) then 
        -- prints the MIV-config settings
        FLC.Debug_testConfig(true);
        
    elseif ( command == "menu" ) then
        -- prints the learned languages
        FLC.Debug_testMenu(true);
        
    elseif ( command == "copy" ) then
        -- prints the learned languages
        FLC.Debug_Copy();
        
    else
        -- shows possible arguments for slash command
        FLC.printInfo("FairLanguage (Core) Debug commands:");
        FLC.printInfo("    /flcdebug config shows the internal configuration of the addon");
        FLC.printInfo("    /flcdebug menu shows the learned languages");
        FLC.printInfo("    /flcdebug copy opens a window for copy the settings for bug reports");
        
    end
end
SLASH_FAIRLANGUAGE_DEBUG_SLASHCMD1 = '/flcdebug'; 