﻿local addonName, FLC = ...; -- gets addon-local variables

FairLanguage = {}; -- public variables and functions

FLC.FairLanguageCore = nil; -- variable for saving at logout

-- bindings.xml
BINDING_HEADER_FAIRLANGUAGE = "FairLanguage";
BINDING_NAME_FLC_BIND_CYCLE = "/flc cycle";
BINDING_NAME_FLC_BIND_TOGGLE = "/flc toggle";
BINDING_NAME_FLC_BIND_WHAT = "/flc ?";

-- constants
FLC.LANGUAGE_MAX_SIZE = 20; -- length of the language name
FLC.LANGUAGEMENU_MAX_SIZE = UIMENU_NUMBUTTONS - 6; -- number of maximal learnable languages

-- default addon-locals
FLC.on = true; -- addon is active

FLC.commonLanguage = ""; -- language of the whole faction
FLC.nativeLanguage = ""; -- special native language

FLC.activeLanguage = ""; -- active language
FLC.tempLanguage = ""; -- temporary language (e.g. for macros, used-only-once)
FLC.prevLanguage = ""; -- the previous used language
FLC.menuLanguagess = {}; -- table of learned languages
FLC.isOwn = false; -- are you speaking your own language?
FLC.numLanguages = 1; -- number of languages
FLC.TMP = "    ->TMP<-   ";
FLC.usedChannels = { -- channel with cleartext
    ["SAY"]          = true, -- RP
    ["YELL"]         = true, -- RP
    ["PARTY"]        = true, -- group/raidS
    ["RAID"]         = true, -- group/raid
    ["RAID_WARNING"] = true, -- group/raid
    ["BATTLEGROUND"] = true, -- PvP
    ["GUILD"]        = true, -- guild
    ["OFFICER"]      = true, -- guild    
}


-- Language IDs per Faction/Race
-- factionGroup, factionName = UnitFactionGroup("unit") or UnitFactionGroup("name")
FLC.factionLangs = {
    ["Horde"] = 1, -- Orcish
    ["Alliance"] = 7, -- Common
    -- ["Neutral"] = 0,
}
-- race, fileName = UnitRace("unit")
FLC.raceLangs = {
    -- Alliance
    ["Alliance"] = {
        ["Human"]       = 7,  -- Common
        ["Dwarf"]       = 6,  -- Dwarven
        ["Gnome"]       = 13, -- Gnomish
        ["NightElf"]    = 2,  -- Darnassian
        ["Draenei"]     = 35, -- Draenei
        ["Worgen"]      = 7,  -- Common
        ["Pandaren"]    = 43, -- Pandaren (Alliance)
    },
    -- Horde
    ["Horde"] = {
        ["Orc"]         = 1,  -- Orc
        ["Tauren"]      = 3,  -- Taurahe
        ["Troll"]       = 14, -- Troll/Zandali
        ["Scourge"]     = 33, -- Gutterspeak
        ["BloodElf"]    = 10, -- Thalassian
        ["Goblin"]      = 40, -- Goblin
        ["Pandaren"]    = 44, -- Pandaren (Horde)
    },
    -- Neutral
    ["Neutral"] = {
        ["Pandaren"]    = 42,  -- Pandaren (Neutral)
    }
}
-- class, classFileName = UnitClassBase("unit") or UnitClassBase("name")
FLC.classLangs = {
    ["WARLOCK"] = 8, -- Demonic
}

-- Buffs affecting the language menu
FLC.buffIDs = { -- true if language tags used
    ["122998"] = true,  -- Arcane Languages (Alliance)
    ["122999"] = true,  -- Arcane Languages (Horde)
    ["103958"] = false, -- Metamorphosis
}

-- local classesEN = {
    -- "NONE",        -- 0
    -- "WARRIOR",     -- 1
    -- "PALADIN",     -- 2
    -- "HUNTER",      -- 3
    -- "ROGUE",       -- 4
    -- "PRIEST",      -- 5
    -- "DEATHKNIGHT", -- 6
    -- "SHAMAN",      -- 7
    -- "MAGE",        -- 8
    -- "WARLOCK",     -- 9
    -- "MONK",        -- 10
    -- "DRUID",       -- 11
-- }


-- color codes
FLC.colors = {
    chatcommand = "|cFFBD70FF",
}

function FLC.printInfo(text) 
    DEFAULT_CHAT_FRAME:AddMessage( text, 1.0, 0.0, 1.0 );
end