﻿local addonName, FLC = ...; -- gets addon-local variables

----------------------------------------------------------------------------------------------------
-- ModifyLanguage

function FLC.partSpeech(s,language, maxlength) 
    local la = FLC.buildTag(language);
    local out1 = "";
    local out2 = "";
    
    local len_la = string.len(la);
    local len_s = string.len(s);
    if (len_la + len_s > maxlength) then
        local neededLength = math.ceil(maxlength / 2); -- parts text likely near the half of the text
        local partIndex = FLC.getPartableIndex(s,neededLength);
        
        out1 = string.sub(s,0,partIndex);
        out2 = string.sub(s,partIndex + 1);
        out1 = strtrim(out1);
        out2 = strtrim(out2);
    
    else
        out1 = s;
    end
    
    return out1, out2;
end

function FLC.enhanceSpeech(tag,out) 
    if( tag ~= nil and out ~= nil and out~="") then
        local p = out;
        
        local b = string.find(out,""..tag,1,true);        
        if (b == nil) then
            p = tag .. out;
        end
        
        return p;
    else
        return out;
    end
end

function FLC.getPartableIndex(s,neededLength)
    local index = 0;
    local sRev = string.reverse(s);
    local start = neededLength;
    
    local _, endPos,_,_ = string.find(sRev, "[\.\!\?]", start);
    local _, endKom,_,_ = string.find(sRev, "%p", start);
    local _, endSpace,_,_ = string.find(sRev, "%s", start);
    
    if (endPos ~= nil) then
        index = endPos;
    elseif (endKom ~= nil) then
        index = endKom;
    else
        index = endSpace;
    end

    index = index * -1;
    return index;
end

function FLC.buildTag( language ) 
    local tag = "\91" .. language .. "\93 "; -- \91 for [ and \93 for ]
    
    for k, v in pairs(FLC.buffIDs) do -- XXX Fix for demonic: suppress tags
        local r = UnitBuff("player", GetSpellInfo(tonumber(k)));
        if r ~= nil and not v then
            tag = "";
        end
    end
    
    return tag;
end


--/ Template / Interface for changing the spoken text without influence on language tag
function FLC.changeArticulation( text, chatType, language, channel )
    return text;
end